""" Encryption modules for pyWiew. This code is not free software and does
 not come under pyWiew licensing. If you need to use it, you need to license
 the code.
 Copyright (C) 2003-2004, Anand B Pillai <abpillai@lycos.com>


 1. XOR obfuscation
 The following is a simple xor obfuscation algorithm.
 It can be used to obfuscate a string without any key.
 Dont use this for encryption since it can be easily hacked. """

def xorobfuscate(data):
	""" A simple cyclic xor algorithm for
	quick n easy data obfuscation """

	out = ""
	a0=ord(data[0])
	a1=ord(data[1])

	e0=chr(a0^a1)
	out += e0

	x=1
	eprev=e0
	while x<len(data):
		ax=ord(data[x])
		ex=chr(ax^ord(eprev))
		out += ex
		#throw some chaff
		chaff = chr(ord(ex)^ax)
		out += chaff
		eprev = ex
		x+=1

	print out
	return out

def xorunobfuscate(data):
	""" Reverse (deobfuscation) of cyclic xor obfuscation """

	out = ""

	x=len(data) - 2

	while x>1:
		apos=data[x]
		aprevpos=data[x-2]

		epos=chr(ord(apos)^ord(aprevpos))
		out += epos
		
		x -= 2

	#reverse string
	out2=""
	x=len(out)-1
	print out
	while x>=0:
		out2 += out[x]
		x -= 1

	out=out2
	#second character
	e2=data[2]
	a2=data[1]

	a1=chr(ord(a2)^ord(e2))
	a1 += out
	out = a1
	#first character
	e1=out[0]
	a1=data[0]

	a0=chr(ord(a1)^ord(e1))
	a0 += out
	out = a0

	print out
	return out
